// APPHelper.cpp: implementation of the APPHelper class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <oleauto.h>//for BSTR support
#include "APPHelper.h"//   Aml Pages

#ifdef _AFX
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
#endif//#ifdef _AFX

//  MFC-
// MFC-  ASSERT  
#ifndef ASSERT
#ifdef _DEBUG
	#include <assert.h>
	#define ASSERT(X) assert(X)
#else// #ifdef _DEBUG
	#define ASSERT(X)
#endif//#ifdef _DEBUG
#endif//#ifndef ASSERT

//  MFC-
// MFC-  TRACE  
#ifndef TRACE
	#ifdef _DEBUG
		#define TRACE(X) OutputDebugString(X)
	#else
		#define TRACE(X) 
	#endif
#endif

/*
       
   Aml Pages

-  ,     
Aml Pages,      .
      Aml Pages (.. GetProcAddress  NULL)
-  
 FALSE (     )

   Aml Pages    APC_
   AmlPages.exe

     :
HMODULE hModule=GetModuleHandle(NULL);// HMODULE AmlPages.exe
GetProcAddress(hModule,_);//    [_]
*/

#define CHECK_STR_PTR(lpsz)	\
	ASSERT(lpsz);	\
	ASSERT(!::IsBadStringPtr(lpsz,INFINITE));

#define CHECK_PTR(ptr,TYPE)	\
	ASSERT(ptr);	\
	ASSERT(!::IsBadReadPtr((void*)ptr,sizeof(TYPE)));	\
	ASSERT(!::IsBadWritePtr((void*)ptr,sizeof(TYPE)));	
	

HWND APPHelper::GetMainHWND()
{
	/* HWND   Aml Pages*/
	HMODULE h=NULL;
	__try {
		h=GetModuleHandle(NULL);
	}
	__except(EXCEPTION_EXECUTE_HANDLER) {
		return NULL;
	}
	
	PFUNC_APC_GETMAINWND pfn=h ? (PFUNC_APC_GETMAINWND)GetProcAddress(h,TEXT("APC_GetMainWnd")) : NULL;

	if (pfn)
		return pfn();
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_GetMainWnd function from AmlPages.exe\n"));
		return NULL;
	}
}

BOOL APPHelper::ConvertText(LPCTSTR lpszInText// 
							,BSTR* pbstrOutText//  (    )
							, const BOOL bRTF2Text//TRUE -  RTF  Plain Text, FALSE  Plain Text  RTF
							)
{
	CHECK_STR_PTR(lpszInText);
	CHECK_PTR(pbstrOutText,BSTR);

	/*  RTF<->PlainText*/
	const HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_CONVERTTEXT pfn=(PFUNC_APC_CONVERTTEXT)GetProcAddress(h,TEXT("APC_ConvertText"));
	if (pfn)
		return pfn(lpszInText,pbstrOutText,bRTF2Text);
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_ConvertText function from AmlPages.exe\n"));
		return FALSE;
	}
}

// MessageBox  
BOOL APPHelper::MessageBoxWithCheckBox(
	LPCTSTR lpszText// MessageBox
	,UINT uType// MessageBox
	,LPCTSTR lpszCheckBoxText// 
	,BOOL* pbChecked// (in-out,    NULL,     
	// )
	,int* pnRet//   MessageBox, 
	//   NULL,     
	)
{
	CHECK_STR_PTR(lpszText);
	CHECK_STR_PTR(lpszCheckBoxText);
	//-  TRUE,     FALSE  
	//  MessageBox    .  pbChecked  pnRet
	CHECK_PTR(pbChecked,BOOL);
	CHECK_PTR(pnRet,int);

	const HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_MESSAGEBOXWITHCHECKBOX pfn=
		(PFUNC_APC_MESSAGEBOXWITHCHECKBOX)GetProcAddress(h,TEXT("APC_MessageBoxWithCheckBox"));
	if (pfn) {
		(*pnRet)=pfn(lpszText,uType,lpszCheckBoxText,pbChecked);
		return TRUE;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_MessageBoxWithCheckBox function from AmlPages.exe\n"));
		return FALSE;
	}
}

//  - 
BOOL APPHelper::DisplayPasswordDialog(
     BSTR* pbstrPassword//out,   ,   ,    NULL
	,BOOL bSetupPassword//TRUE,   , FALSE     ( ,     )
	,BOOL bTopMost//     (TRUE)
	,LPCTSTR lpszPrevPassword// ,  NULL .  
	,BOOL bShowOnEnter//    (TRUE),  FALSE   ()
	,LPCTSTR lpszTitle)//  
{
	CHECK_PTR(pbstrPassword,BSTR);
	// FALSE    ,    
	// TRUE        ( OK)
	const HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_DISPLAYPASSWORDDIALOG pfn
		=(PFUNC_APC_DISPLAYPASSWORDDIALOG)GetProcAddress(h,TEXT("APC_DisplayPasswordDialog"));
	if (pfn) {
		BOOL b=pfn(pbstrPassword,bSetupPassword,bTopMost,lpszPrevPassword,bShowOnEnter,lpszTitle);
		return b;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_DisplayPasswordDialog function from AmlPages.exe\n"));
		return FALSE;
	}
}

//   Aml Pages (  ,      )
UINT APPHelper::GetAmlPagesBuildNumber()
{
	const HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_GETAMLPAGESBUILDNUMBER pfn=
		(PFUNC_APC_GETAMLPAGESBUILDNUMBER)GetProcAddress(h,TEXT("APC_GetAmlPagesBuildNumber"));
	if (pfn) {
		const UINT nRet=pfn();
		return nRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_GetAmlPagesBuildNumber function from AmlPages.exe\n"));
		return 0;
	}
}

//        lpszPathName
BOOL APPHelper::GetModuleVersionInfo(
	LPCTSTR lpszPathName
	, AML_MODULEVERSIONINFO *pVersionInfo)
{
	CHECK_STR_PTR(lpszPathName);
	CHECK_PTR(pVersionInfo,AML_MODULEVERSIONINFO);
	// TRUE   
	ASSERT(pVersionInfo);
	if (!pVersionInfo) return FALSE;

	const HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_GETMODULEVERSIONINFO pfn=
		(PFUNC_APC_GETMODULEVERSIONINFO)GetProcAddress(h,TEXT("APC_GetModuleVersionInfo"));
	if (pfn) {
		const BOOL bRet=pfn(lpszPathName,pVersionInfo);
		return bRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_GetModuleVersionInfo function from AmlPages.exe\n"));
		return FALSE;
	}
}

//   
BOOL APPHelper::ReReadPluginsInfo(
								  HMODULE hModule// NULL  , 
								  // -NULL       hModule
								  )
{
	//TRUE-  
	const HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_REREADPLUGINSINFO pfn=
		(PFUNC_APC_REREADPLUGINSINFO)GetProcAddress(h,TEXT("APC_ReReadPluginsInfo"));
	if (pfn) {
		const BOOL bRet=pfn(hModule);
		return bRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_ReReadPluginsInfo function from AmlPages.exe\n"));
		return FALSE;
	}
}

//    Aml Pages, 
//  AML_OPTIONS   
//.  plugins.h, 
BOOL APPHelper::GetOptions(AML_OPTIONS *pOpt)
{
	//TRUE   
	//  , pOpt -    NULL
	CHECK_PTR(pOpt,AML_OPTIONS);
	const HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_GETOPTIONS pfn=(PFUNC_APC_GETOPTIONS)GetProcAddress(h,TEXT("APC_GetOptions"));
	if (pfn) {
		const BOOL bRet=pfn(pOpt);
		return bRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_GetOptions function from AmlPages.exe\n"));
		return FALSE;
	}
}

//   
// .  plugins.h
BOOL APPHelper::GetAutoTextCommand(AML_AUTOTEXTCOMMAND *pCmd)
{
	//  pCmd    
	//TRUE -   
	CHECK_PTR(pCmd,AML_AUTOTEXTCOMMAND );
	const HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_GETAUTOTEXTCOMMAND pfn=
		(PFUNC_APC_GETAUTOTEXTCOMMAND)GetProcAddress(h,TEXT("APC_GetAutoTextCommand"));
	if (pfn) {
		const BOOL bRet=pfn(pCmd);
		return bRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_GetAutoTextCommand function from AmlPages.exe\n"));
		return FALSE;
	}
}

//   
// .  plugins.h
BOOL APPHelper::PluginAbout(AML_PLUGINABOUTINFO *pInfo)
{
	CHECK_PTR(pInfo,AML_PLUGINABOUTINFO);
	//  pInfo    
	//TRUE -   
	const HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_PLUGINABOUT pfn=
		(PFUNC_APC_PLUGINABOUT)GetProcAddress(h,TEXT("APC_PluginAbout"));
	if (pfn) {
		const BOOL bRet=pfn(pInfo);
		return bRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_PluginAbout function from AmlPages.exe\n"));
		return FALSE;
	}
}

//-    RichEdit
static
BOOL RichInOut(AML_RICHEDITIO *p)
{
	CHECK_PTR(p,AML_RICHEDITIO);
	//    
	//TRUE -   
	const HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_RICHINOUT pfn=
		(PFUNC_APC_RICHINOUT)GetProcAddress(h,TEXT("APC_RichInOut"));
	if (pfn) {
		const BOOL bRet=pfn(p);
		return bRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_RichInOut function from AmlPages.exe\n"));
		return FALSE;
	}
}

//    RichEdit
BOOL APPHelper::RichIn(AML_RICHEDITIO *p)
{
	//    
	//TRUE -   
	CHECK_PTR(p,AML_RICHEDITIO);
	if (!p)
		return FALSE;
	
	p->dwFlags|=APFRIO_IN;
	return RichInOut(p);
}

//    RichEdit
BOOL APPHelper::RichOut(AML_RICHEDITIO *p)
{
	//    
	//TRUE -   
	CHECK_PTR(p,AML_RICHEDITIO);
	if (!p) return FALSE;
	
	ASSERT(0==(p->dwFlags & APFRIO_IN));
	if (p->dwFlags & APFRIO_IN)
		p->dwFlags^=APFRIO_IN;

	return RichInOut(p);
}

//      hModule
BOOL APPHelper::GetModuleVersionInfoEx(HMODULE hModule
									   , AML_MODULEVERSIONINFO *pInfo)
{
	//    
	//TRUE -   
	CHECK_PTR(pInfo,AML_MODULEVERSIONINFO );
	const HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_GETMODULEVERSIONINFOEX pfn=
		(PFUNC_APC_GETMODULEVERSIONINFOEX)GetProcAddress(h,TEXT("APC_GetModuleVersionInfoEx"));
	if (pfn) {
		const BOOL bRet=pfn(hModule,pInfo);
		return bRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_GetModuleVersionInfoEx function from AmlPages.exe\n"));
		return FALSE;
	}
}

//MessageBox  radio-buttons
BOOL APPHelper::MessageBoxWithRadioBox(AML_MBRADIOINFO *pInfo)
{
	//  pInfo  ,      	
	CHECK_PTR(pInfo,AML_MBRADIOINFO);;//    NULL
	ASSERT(pInfo->bstrText);//  MessageBox    NULL
	ASSERT(pInfo->bstrButtonsText);//        NULL
	//       "Radio Button Text 0\nRadio Button Text 1\n"
	//      "\n"+1,  "\n"   ,  

	PFUNC_APC_MESSAGEBOXWITHRADIO pfn=(PFUNC_APC_MESSAGEBOXWITHRADIO)GetProcAddress(GetModuleHandle(NULL)
		,TEXT("APC_MessageBoxWithRadioBox"));
	if (pfn) {
		const BOOL b=pfn(pInfo);
		return b;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_MessageBoxWithRadioBox function from AmlPages.exe\n"));
		return FALSE;
	}
}

/* MessageBox   */
BOOL APPHelper::MessageBoxWithCheckBoxEx(AML_MBCHECKINFO *pInfo)
{
	CHECK_PTR(pInfo,AML_MBCHECKINFO);/*  ?*/
	ASSERT(pInfo->bstrText);/* . MessageBox   */
	ASSERT(pInfo->bstrButtonsText);/*    */
	ASSERT(pInfo->cbSize);/*    sizeof(AML_MBCHECKINFO)*/
	ASSERT(pInfo->pbChecked);/*    */
	
	PFUNC_APC_MESSAGEBOXWITHCHECKBOXEX pfn=(PFUNC_APC_MESSAGEBOXWITHCHECKBOXEX)GetProcAddress(
		GetModuleHandle(NULL),TEXT("APC_MessageBoxWithCheckBoxEx"));
	if (pfn)
		return pfn(pInfo);
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_MessageBoxWithCheckBoxEx function from AmlPages.exe\n"));
		return FALSE;
	}
}

static
BSTR BSTRFromLPCTSTR(LPCTSTR lpsz)
{
	if ((IsBadStringPtr(lpsz,INFINITE)) || (!strlen(lpsz))) return NULL;

	const int nLen = MultiByteToWideChar(CP_ACP, 0, lpsz,
		strlen(lpsz) ,NULL, NULL);
	
	BSTR bstr = ::SysAllocStringLen(NULL, nLen);
	
	if (bstr )
		MultiByteToWideChar(CP_ACP, 0, lpsz, strlen(lpsz),bstr, nLen);

	return bstr;
}


BOOL APPHelper::PluginAbout(
	LPCTSTR lpszAbout
	, LPCTSTR lpszCopy
	, LPCTSTR lpszLink
	, LPCTSTR lpszNameVersion
	, LPCTSTR lpszURLToolTip
	, LPCTSTR lpszTitle
	, const HICON hIcon
	, LPCTSTR lpszLinkText)
{
	AML_PLUGINABOUTINFO pa;
	pa.bstrAbout=BSTRFromLPCTSTR(lpszAbout);
	pa.bstrCopyrights=BSTRFromLPCTSTR(lpszCopy);
	pa.bstrLink=BSTRFromLPCTSTR(lpszLink);
	pa.bstrNameVersion=BSTRFromLPCTSTR(lpszNameVersion);
	pa.bstrTitle=BSTRFromLPCTSTR(lpszTitle);
	pa.bstrURLToolTip=BSTRFromLPCTSTR(lpszURLToolTip);
	pa.lpszLinkText=lpszLinkText;
	pa.hIcon=hIcon;

	const BOOL b=PluginAbout(&pa);
	if (pa.bstrAbout)
		SysFreeString(pa.bstrAbout);
	if (pa.bstrCopyrights)
		SysFreeString(pa.bstrCopyrights);
	if (pa.bstrLink)
		SysFreeString(pa.bstrLink);
	if (pa.bstrNameVersion)
		SysFreeString(pa.bstrNameVersion);
	if (pa.bstrTitle)
		SysFreeString(pa.bstrTitle);
	if (pa.bstrURLToolTip)
		SysFreeString(pa.bstrURLToolTip);

	return b;
}

//     Aml Pages
BOOL APPHelper::SetStatusBarText(BSTR bstr)
{
	//bstr    BSTR,     ,    NULL

	ASSERT(bstr);
	
	PFUNC_APC_SETSTATUSBARTEXT pfn=(PFUNC_APC_SETSTATUSBARTEXT)GetProcAddress(GetModuleHandle(NULL)
		,TEXT("APC_SetStatusBarText"));

	if (pfn)
		return pfn(bstr);
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_SetStatusBarText function from AmlPages.exe\n"));
		return FALSE;
	}
}

BOOL APPHelper::SetStatusBarText(LPCTSTR lpszText)
{
	ASSERT(!IsBadStringPtr(lpszText,INFINITE));
	ASSERT(strlen(lpszText));

	const BSTR bstr=BSTRFromLPCTSTR(lpszText);
	ASSERT(bstr);

	const BOOL b=APPHelper::SetStatusBarText(bstr);
	
	if(bstr)
		SysFreeString(bstr);

	return b;
}

BOOL APPHelper::RichInPlainTextAll(const HWND hwnd, LPCTSTR lpszText)
{
	return RichIn(hwnd,lpszText,true,false);
}

BOOL APPHelper::RichInPlainTextSel(const HWND hwnd, LPCTSTR lpszText)
{
	return RichIn(hwnd,lpszText,true,true);
}

BOOL APPHelper::RichInRTFTextAll(const HWND hwnd, LPCTSTR lpszText)
{
	return RichIn(hwnd,lpszText,false,false);
}

BOOL APPHelper::RichInRTFTextSel(const HWND hwnd, LPCTSTR lpszText)
{
	return RichIn(hwnd,lpszText,false,true);
}

BOOL APPHelper::RichIn(const HWND hwnd
					   , LPCTSTR lpszText
					   , const bool bAsPlainText
					   , const bool bSel)
{
	ASSERT(IsWindow(hwnd));
	ASSERT(!IsBadStringPtr(lpszText,INFINITE));
	ASSERT(strlen(lpszText));

	AML_RICHEDITIO io;
	io.bstrText=BSTRFromLPCTSTR(lpszText);
	io.hwndRichEdit=hwnd;
	if (bAsPlainText)
		io.dwFlags|=APFRIO_PLAINTEXT;
	if(bSel)
		io.dwFlags|=APFRIO_SEL;

	const BOOL b=RichIn(&io);
	if (io.bstrText)
		SysFreeString(io.bstrText);

	return b;
}

int APPHelper::EnumAttachments(WORD wDocID
 							 , PFUNC_ENUMATTACHMENTSPROC pfn
 							 , LPARAM lParam
 							 , LPCTSTR lpszINFOID
 							 , int nPageID)
{
	ASSERT(!IsBadCodePtr((FARPROC)pfn));
 #ifdef _DEBUG
 	if (lpszINFOID) {
 		ASSERT(!IsBadStringPtr(lpszINFOID,INFINITE));
 		ASSERT(strlen(lpszINFOID));
 	}
 #endif
 
 	const HMODULE h=GetModuleHandle(NULL);
 	PFUNC_APC_ENUMATTACHMENTS p=
 		(PFUNC_APC_ENUMATTACHMENTS)GetProcAddress(h,TEXT("APC_EnumAttachments"));

	if (NULL==p)
		p=(PFUNC_APC_ENUMATTACHMENTS)GetProcAddress(h,TEXT("APC_EnumExtraInfo"));

 	if (p) {
 		const int nRet=p(wDocID,pfn,lpszINFOID,nPageID,lParam);
 		return nRet;
 	}
 	else
 		return -1;
}


BOOL APPHelper::RemoveAttachment(WORD wDocID, int nIndex)
{
	ASSERT(nIndex>=0);
 	const HMODULE h=GetModuleHandle(NULL);
 	
	PFUNC_APC_REMOVEATTACHMENT p=
		(PFUNC_APC_REMOVEATTACHMENT)GetProcAddress(h,TEXT("APC_RemoveAttachment"));

	if (NULL==p)
		p=(PFUNC_APC_REMOVEATTACHMENT)GetProcAddress(h,TEXT("APC_RemoveExtraInfo"));

 	if (p) {
 		const int nRet=p(wDocID,nIndex);
 		return nRet;
 	}
 	else
 		return -1;
}

BOOL APPHelper::SetAttachment(WORD wDocID, int nIndex, AML_ATTACHINFO *p)
{
	ASSERT(nIndex>=0);
	ASSERT(!IsBadReadPtr(p,sizeof(AML_ATTACHINFO)));

	const HMODULE h=GetModuleHandle(NULL);

	PFUNC_APC_SETATTACHMENT pFunc=
		(PFUNC_APC_SETATTACHMENT)GetProcAddress(h,TEXT("APC_SetAttachment"));

	if (NULL==pFunc)
		pFunc=(PFUNC_APC_SETATTACHMENT)GetProcAddress(h,TEXT("APC_SetExtraInfo"));
 	
	if (pFunc) {
 		const int nRet=pFunc(wDocID,nIndex,p);
 		return nRet;
 	}
 	else
		return FALSE;
}

struct GET_ATTACH_PARAM {
	AML_ATTACHINFO& ae;
	const int nIndex;
	BOOL bRet;
	GET_ATTACH_PARAM (AML_ATTACHINFO& e, int index):ae(e),nIndex(index),bRet(FALSE)
	{
	}	
};

static
BOOL GetAttachmentProc(int nIndex, AML_ATTACHINFO* pInfo, LPARAM lParam)
{
	GET_ATTACH_PARAM* const pParam=reinterpret_cast<GET_ATTACH_PARAM*>(lParam);
	ASSERT(!IsBadWritePtr((void*)pParam,sizeof(GET_ATTACH_PARAM)));
	if (pParam->nIndex==nIndex) {
		if (pInfo->dwInfoSize) {
			//pParam->ae.pInfo=new unsigned char[pInfo->dwInfoSize];
			pParam->ae.Alloc(pInfo->dwInfoSize);
			ASSERT(!IsBadWritePtr(pParam->ae.pInfo,pInfo->dwInfoSize));
			memcpy(pParam->ae.pInfo,pInfo->pInfo,pInfo->dwInfoSize);
			pParam->ae.dwInfoSize=pInfo->dwInfoSize;
		}
		pParam->ae.nPageID=pInfo->nPageID;
		pParam->ae.stDateCreated=pInfo->stDateCreated;
		pParam->ae.stDateModified=pInfo->stDateModified;
		pParam->bRet=TRUE;
		
		return FALSE;//end enum
	}

	return TRUE;	//continue enum
}

BOOL APPHelper::GetAttachment(const WORD wDocID, const int nIndex, AML_ATTACHINFO *p)
{
	ASSERT(nIndex>=0);
	ASSERT(!IsBadWritePtr(p,sizeof(AML_ATTACHINFO)));
	if(IsBadWritePtr(p,sizeof(AML_ATTACHINFO)))
		return FALSE;

	ASSERT(NULL==p->pInfo);
	ASSERT(0==p->dwInfoSize);

	GET_ATTACH_PARAM param(*p,nIndex);
	APPHelper::EnumAttachments(wDocID,GetAttachmentProc,(LPARAM)&param,p->lpszInfoID,p->nPageID);

	return param.bRet;	
}

int APPHelper::GetActivePage(const WORD wDocID)
{
	const HMODULE h=GetModuleHandle(NULL);
 	
	PFUNC_APC_GETACTIVEPAGE p=
		(PFUNC_APC_GETACTIVEPAGE )GetProcAddress(h,TEXT("APC_GetActivePage"));
 	
	if (p) {
 		const int nRet=p(wDocID);
 		return nRet;
 	}
 	else
 		return -1;
}

WORD APPHelper::GetUILanguage()
{
	const HMODULE h=GetModuleHandle(NULL);
 	
	PFUNC_APC_GETUILANGUAGE p=
		(PFUNC_APC_GETUILANGUAGE)GetProcAddress(h,TEXT("APC_GetUILanguage"));
 	
	if (p) {
 		const int nRet=p();
 		return nRet;
 	}
 	else
 		return 0;
}

UINT APPHelper::MessageBoxWith2Radio(const HWND hwndParent
									 , UINT nType
									 , LPCTSTR lpszTitle
									 , LPCTSTR lpszText
									 , LPCTSTR lpszRadio1
									 , LPCTSTR lpszRadio2
									 , UINT& nRadio)
{
	const int nLen=strlen(lpszRadio1)+2+strlen(lpszRadio2)+2;
	char* const p=new char[nLen];
	memset(p,0,nLen);
	strcat(p,lpszRadio1);
	strcat(p,TEXT("\n"));
	strcat(p,lpszRadio2);

	AML_MBRADIOINFO mb;
	mb.cbSize=sizeof(mb);
	mb.bstrButtonsText=BSTRFromLPCTSTR(p);
	mb.bstrCaption=BSTRFromLPCTSTR(lpszTitle);
	mb.bstrText=BSTRFromLPCTSTR(lpszText);
	mb.hwndParent=hwndParent;
	mb.nChecked=nRadio;
	mb.uType=nType;

	const BOOL b=APPHelper::MessageBoxWithRadioBox(&mb);
	UINT nRet=0;
	if (b) {
		nRet=mb.nRetValue;
		nRadio=mb.nChecked;
	}
	SysFreeString(mb.bstrButtonsText);
	SysFreeString(mb.bstrCaption);
	SysFreeString(mb.bstrText);
	
	delete[] p;

	return nRet;
}

BOOL APPHelper::IsHasAPC_REMOVEATTACHMENTEX()
{
	const HMODULE h=GetModuleHandle(NULL);
 	
	void* const p=
		GetProcAddress(h,TEXT("APC_RemoveAttachmentEx"));
	if (NULL==p)
		GetProcAddress(h,TEXT("APC_RemoveExtraInfoEx"));

	return (NULL!=p);
}

BOOL APPHelper::RemoveAttachmentToRecycledBin(const WORD wDocID, const int nIndex)
{
	const HMODULE h=GetModuleHandle(NULL);
 	
	PFUNC_APC_REMOVEATTACHMENTEX pfunc=
		(PFUNC_APC_REMOVEATTACHMENTEX)GetProcAddress(h,TEXT("APC_RemoveAttachmentEx"));
	
	if (NULL==pfunc)
		pfunc=(PFUNC_APC_REMOVEATTACHMENTEX)GetProcAddress(h,TEXT("APC_RemoveExtraInfoEx"));

	if (NULL==pfunc)
		return FALSE;
	else
		return pfunc(wDocID,nIndex,AML_REMOVEATTACHMENTTORECYCLED);
}

BOOL APPHelper::AddAttachment(WORD wDocID, AML_ATTACHINFO* p)
{
	ASSERT(!IsBadReadPtr(p,sizeof(AML_ATTACHINFO)));

	const HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_ADDATTACHMENT pfn=
		(PFUNC_APC_ADDATTACHMENT)GetProcAddress(h,TEXT("APC_AddAttachment"));

	if (NULL==pfn)
		pfn=(PFUNC_APC_ADDATTACHMENT)GetProcAddress(h,TEXT("APC_AddExtraInfo"));

	if (pfn) {
		const BOOL b=pfn(wDocID,p);
		return b;
	}
	else
		return FALSE;

}

BOOL APPHelper::AddStringToAttachment(WORD wDocID,LPCTSTR lpsz, LPCTSTR lpszInfoID, const int nPageID)
{
	ASSERT(!IsBadStringPtr(lpsz,INFINITE));
	ASSERT(strlen(lpsz));
#ifdef _DEBUG
	if (lpszInfoID) {
		ASSERT(!IsBadStringPtr(lpszInfoID,INFINITE));
		ASSERT(strlen(lpszInfoID));
	}
#endif

	AML_ATTACHINFO ae;
	ae.dwInfoSize=strlen(lpsz);
	ae.pInfo=(unsigned char*)lpsz;
	ae.lpszInfoID=lpszInfoID;
	ae.nPageID=nPageID;

	return AddAttachment(wDocID,&ae);
}

LRESULT APPHelper::Command(UINT nCmd, WPARAM wParam, LPARAM lParam)
{
	const HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_COMMAND pfn=
		(PFUNC_APC_COMMAND)GetProcAddress(h,TEXT("APC_Command"));
	if (pfn) {
		const LRESULT nRet=pfn(nCmd,wParam,lParam);
		return nRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_COMMAND function from AmlPages.exe\n"));
		return 0;
	}
}

int APPHelper::GetActivePageID(const WORD wDocumentID)
{
	return Command(AC_GETACTIVEPAGEID,wDocumentID,0);
}

int APPHelper::GetPageHeader(const int nPageID, LPTSTR lpszHeader)
{
	return Command(AC_GETPAGEHEADER,nPageID,(LPARAM)lpszHeader);
}

int APPHelper::GetPageHeaderBytesNeed(const int nPageID)
{
	return GetPageHeader(nPageID,NULL);
}

BOOL APPHelper::ShowTree(const WORD wDocID, const BOOL bShow)
{
	return Command(AC_SHOWTREE,wDocID,bShow);
}

UINT APPHelper::GetMruListSizeInBytes()
{
	return Command(AC_GETMRUFILESLIST,0,NULL);
}

UINT APPHelper::GetMruList(const UINT nBytes, LPTSTR lpszFileList)
{
	ASSERT(!IsBadWritePtr(lpszFileList,nBytes));
	return Command(AC_GETMRUFILESLIST,nBytes,(LPARAM)lpszFileList);
}

WORD APPHelper::OpenDocument(LPCTSTR lpszDocFullPathName)
{
	ASSERT(!IsBadStringPtr(lpszDocFullPathName,INFINITE));
	ASSERT(strlen(lpszDocFullPathName));
	return (WORD)Command(AC_OPENDOCUMENT,NULL,(LPARAM)lpszDocFullPathName);
}

BOOL APPHelper::CopyNode(const int nCopiedNodeID, const int nTargetNodeID)
{
	return APPHelper::CopyOrMoveNode(nCopiedNodeID, nTargetNodeID,TRUE);
}

BOOL APPHelper::MoveNode(const int nCopiedNodeID, const int nTargetNodeID)
{
	return APPHelper::CopyOrMoveNode(nCopiedNodeID, nTargetNodeID,FALSE);
}

BOOL APPHelper::CopyOrMoveNode(const int nCopiedNodeID
					, const int nTargetNodeID, const BOOL bCopy)
{
	return APPHelper::Command(bCopy ? AC_COPYNODE : AC_MOVENODE,nCopiedNodeID,nTargetNodeID);
}

COLORREF APPHelper::GetAmlColor(const AML_OPTIONS_COLORS colorType)
{
	AML_OPTIONS opt;
	switch(colorType) {
	case AOC_TREEBK:
		opt.dwMask=APFOPT_BKTREECOLOR;
		break;
	case AOC_TREEFONT:
		opt.dwMask=APFOPT_TREECOLOR;
		break;
	case AOC_EDITORFONT:
		opt.dwMask=APFOPT_EDITORCOLOR;
		break;
	case AOC_EDITORBK:
		opt.dwMask=APFOPT_BKEDITORCOLOR;		
		break;
	}//switch(colorType) {

	const BOOL b=APPHelper::GetOptions(&opt);
	if (!b)
		return 0;
	
	switch(colorType) {
	case AOC_TREEBK:
		return opt.dwBkTreeColor;
		break;
	case AOC_TREEFONT:
		return opt.dwTreeColor;
		break;
	case AOC_EDITORFONT:
		return opt.dwEditorColor;
		break;
	case AOC_EDITORBK:
		return opt.dwBkEditorColor;
		break;
	default:
		ASSERT(FALSE);
		return 0;
	}//switch(colorType) {
}

int APPHelper::GetActiveDocumentPathNeedBytes()
{
	const int n=Command(AC_GETACTIVEDOCUMENTPATH,0,NULL);
	return n;
}

int APPHelper::GetActiveDocumentPath(UINT nBytes, LPTSTR lpszPath)
{
	ASSERT(!IsBadWritePtr(lpszPath,nBytes));

	const int n=Command(AC_GETACTIVEDOCUMENTPATH,nBytes,(LPARAM)lpszPath);
	return n;
}

WORD APPHelper::OpenDocumentEx(LPCTSTR lpszFullPathName, const int nPageID)
{
	return (WORD)Command(AC_OPENDOCUMENTEX,nPageID,(LPARAM)lpszFullPathName);
}

BOOL APPHelper::RestoreMainWindow()
{
	return Command(AC_SHOWMAINWINDOW,SC_RESTORE,0);
}

BOOL APPHelper::MinimizeMainWindow()
{
	return Command(AC_SHOWMAINWINDOW,SC_MINIMIZE,0);
}

BOOL APPHelper::ShowPageInTree(const WORD wDocID, const int nPageID)
{
	return Command(AC_SHOWPAGEINTREE,wDocID,nPageID);
}

BOOL APPHelper::ShowPageInTreeInActiveDoc(const int nPageID)
{
	return ShowPageInTree(AML_ACTIVEDOCUMENTID,nPageID);
}

int APPHelper::ImportFileToActiveDoc(LPCTSTR lpszPathName)
{
	ASSERT(!IsBadStringPtr(lpszPathName,INFINITE));
	return Command(AC_IMPORTFILE,-1,(LPARAM)lpszPathName);
}

LOGFONT APPHelper::GetAmlTreeFont()
{
	AML_OPTIONS opt;
	opt.dwMask=APFOPT_TREEFONT;
	const BOOL b=GetOptions(&opt);
	ASSERT(b);

	return opt.lfTreeFont;
}

LOGFONT APPHelper::GetAmlEditorFont()
{
	AML_OPTIONS opt;
	opt.dwMask=APFOPT_EDITORFONT;
	const BOOL b=GetOptions(&opt);
	
	return opt.lfEditorFont;
}

CHARFORMAT APPHelper::GetAmlEditorFontAsCHARFORMAT()
{
	AML_OPTIONS opt;
	opt.dwMask=APFOPT_EDITORFONT;
	const BOOL b=GetOptions(&opt);
	ASSERT(b);

	return opt.cfEditorFont;
}

int APPHelper::DisplayFolderDialogForActiveDoc(const int nSelFolderID, RECT *pRectDlg)
{
	return Command(AC_DISPLAYFOLDERDIALOG,nSelFolderID,(LPARAM)pRectDlg);
}

BOOL APPHelper::SelectPage(const WORD wDocID, const int nPageID, const DWORD dwCursorPos)
{
	AML_PAGEINFO pi;
	memset(&pi,0,sizeof(pi));
	pi.cbSize=sizeof(pi);
	pi.nPageID=nPageID;
	pi.lCursorPos=dwCursorPos;

	return Command(AC_SELECTPAGE,wDocID,(LPARAM)&pi);
}

UINT APPHelper::GetManagementFilesListSizeInBytes()
{
	return Command(AC_GETMANAGEMENTFILESLIST,0,NULL);
}

UINT APPHelper::GetManagementFilesList(const UINT cbBufferBytes, char *const pBuffer)
{
	return Command(AC_GETMANAGEMENTFILESLIST,cbBufferBytes,(LPARAM)pBuffer);
}

void APPHelper::GetPluginsDirectory(char *psz, const UINT n)
{
	ASSERT(!IsBadWritePtr(psz,n));
	
	TCHAR szPath[MAX_PATH+1]={0};
	GetModuleFileName(NULL,szPath,MAX_PATH);

	TCHAR szDrive[_MAX_DRIVE]={0};
	TCHAR szDir[_MAX_DIR]={0};

	_splitpath(szPath,szDrive,szDir,NULL,NULL);
	strcpy(psz,szDrive);
	strcat(psz,szDir);
	
	const int nLen=strlen(psz);
	if (nLen && strcmp((psz+nLen-1),"\\"))
		strcat(psz,"\\");

	strcat(psz,TEXT("Plugins"));
}

BOOL APPHelper::IsReadOnlyDocument(const WORD wDocID)
{
	return Command(AC_ISREADONLYDOCUMENT,wDocID,0);
}

BOOL APPHelper::IsReadOnlyActiveDocument()
{
	return IsReadOnlyDocument(AML_ACTIVEDOCUMENTID);
}

BOOL APPHelper::GetFilenameFromPath(LPCTSTR lpszPath
									, LPTSTR lpszFilename
									, const UINT nSize)
{
	ASSERT(!IsBadStringPtr(lpszPath,INFINITE));
	ASSERT(!IsBadWritePtr(lpszFilename,nSize));

	if(IsBadStringPtr(lpszPath,INFINITE))
		return false;
	if(nSize && IsBadWritePtr(lpszFilename,nSize))
		return false;

	TCHAR szFNAME[_MAX_FNAME]={0};
	TCHAR szExt[_MAX_EXT]={0};

	_splitpath(lpszPath,NULL,NULL,szFNAME,szExt);
	const UINT nRequired=strlen(szFNAME)*sizeof(TCHAR)
		+strlen(szExt)*sizeof(TCHAR)
		+sizeof(TCHAR);

	if (!nSize)
		return nRequired;
	else {
		if (nRequired>nSize)
			return 0;
		else {
			strncpy(lpszFilename,szFNAME,nSize);
			strncat(lpszFilename,szExt,nSize);
			return nRequired;
		}
	}
}

int APPHelper::ReadTipOfTheDay(const UINT nBufferInBytesSize
							   , LPTSTR lpszBuffer)
{
	ASSERT(!IsBadWritePtr(lpszBuffer,nBufferInBytesSize));
	return Command(AC_READTIPOFTHEDAY
		,nBufferInBytesSize
		,(LPARAM)lpszBuffer);
}

BOOL APPHelper::NewStickyNoteToTheDocument(const BOOL bInsertClipboardToContent
										   , LPCTSTR lpszDocumentPath)
{
	ASSERT(!IsBadStringPtr(lpszDocumentPath,INFINITE));
	ASSERT(strlen(lpszDocumentPath));

	const BOOL b=Command(AC_NEWSTICKYNOTE
		,bInsertClipboardToContent
		,(LPARAM)lpszDocumentPath);
	return b;
}

void APPHelper::NewStickyNote(const BOOL bInsertClipboardToContent)
{
	Command(AC_NEWSTICKYNOTE,bInsertClipboardToContent,0);
}


BOOL APPHelper::DisplayFavoritesMenuForActiveDocument(POINT pt)
{
	return Command(AC_DISPLAYFAVORITESMENU,AML_ACTIVEDOCUMENTID,MAKELPARAM(pt.x,pt.y));
}

HICON APPHelper::ExtractPageIcon(const WORD wDocumentID, const int nPageID)
{
	return (HICON)Command(AC_EXTRACTPAGEICON,wDocumentID,nPageID);
}

HICON APPHelper::ExtractPageIconFromActiveDocument(const int nPageID)
{
	return ExtractPageIcon(AML_ACTIVEDOCUMENTID,nPageID);
}

BOOL APPHelper::DisplayAsStickyNote(const WORD wDocID, const int nPageID, const BOOL bDisplay)
{
	const WPARAM wParam=MAKEWPARAM(wDocID,bDisplay);
	return Command(AC_DISPLAYASSTICKYNOTE,wParam,nPageID);
}

BOOL APPHelper::DisplayActiveDocumentAsStickyNote(const int nPageID, const BOOL bDisplay)
{
	return DisplayAsStickyNote(AML_ACTIVEDOCUMENTID,nPageID,bDisplay);
}

BOOL APPHelper::SetOptions(const AML_OPTIONS *const pOpt)
{
	ASSERT(!IsBadReadPtr(pOpt,SIZE_AML_OPTIONS_VER3));
	return Command(AC_SETOPTIONS,0,(LPARAM)pOpt);
}

BOOL APPHelper::GetModuleVersionInfoOfAmlPages(AML_MODULEVERSIONINFO *pVersionInfo)
{
	TCHAR szPath[MAX_PATH+1]={0};
	GetModuleFileName(NULL,szPath,sizeof(szPath)/sizeof(TCHAR));
	
	return GetModuleVersionInfo(szPath,pVersionInfo);
}

WORD APPHelper::DocumentPathToID(LPCTSTR lpszDocumentPath)
{
	ASSERT(!IsBadStringPtr(lpszDocumentPath,INFINITE));
	ASSERT(strlen(lpszDocumentPath));

	const WORD wDoc=(WORD)Command(AC_DOCUMENTPATHTOID,(WPARAM)lpszDocumentPath,0);
	return wDoc;
}

BOOL APPHelper::ExecUserCommand(const WPARAM wParam, const LPARAM lParam)
{
	return Command(AC_EXECUSERCOMMAND,wParam,lParam);
}

BOOL APPHelper::InsertPictureFromFile(WPARAM wDocID, LPCTSTR lpszPicFilename)
{
	ASSERT(!IsBadStringPtr(lpszPicFilename,INFINITE));
	ASSERT(strlen(lpszPicFilename));

	return Command(AC_INSERTPICTUREFROMFILE,wDocID,(LPARAM)lpszPicFilename);
}

BOOL APPHelper::SaveActiveDocumentAsDefaultCompressions()
{
	return Command(AC_EXECUSERCOMMAND,AMLUC_FILE_DOCUMENTSAVE,0);
}
