// DlgInsertTable.cpp : implementation file
//

#include "stdafx.h"
#include "TblMaker.h"
#include "DlgInsertTable.h"
#include "PlugRegUtil.h"

extern CTblMakerApp theApp;

#ifndef _DEBUG
	#define KEY_PATH TEXT("Software\\G&G Software\\Aml Pages\\Plugins\\Table Maker")
#else
	#define KEY_PATH TEXT("Software\\G&G Software\\Aml Pages\\Plugins\\Table Maker Debug2")
#endif//#ifndef _DEBUG

#define ROWS TEXT("Rows")
#define COLS TEXT("Cols")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CDlgInsertTable::CDlgInsertTable(WORD wLangID,CWnd* pParent /*=NULL*/)
	: CDialog(CDlgInsertTable::IDD, pParent)
	,m_wLangID(wLangID)
{
	//{{AFX_DATA_INIT(CDlgInsertTable)
	m_nCols = 2;
	m_nRows = 2;
	//}}AFX_DATA_INIT
	m_nCols=PlugRegUtil::ReadValue(KEY_PATH,COLS,m_nCols);
	m_nRows=PlugRegUtil::ReadValue(KEY_PATH,ROWS,m_nRows);
}

void CDlgInsertTable::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgInsertTable)
	DDX_Text(pDX, IDC_EDIT_COLS, m_nCols);
	DDV_MinMaxUInt(pDX, m_nCols, 1, 100);
	DDX_Text(pDX, IDC_EDIT_ROWS, m_nRows);
	DDV_MinMaxUInt(pDX, m_nRows, 1, 1000);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgInsertTable, CDialog)
	//{{AFX_MSG_MAP(CDlgInsertTable)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CDlgInsertTable::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	ReverseSpin(IDC_SPIN_COLS);
	ReverseSpin(IDC_SPIN_ROWS);
	Localize();
	
	return TRUE;
}

void CDlgInsertTable::ReverseSpin(const UINT nID)
{
	CSpinButtonCtrl* const pCtrl=(CSpinButtonCtrl*)GetDlgItem(nID);
	ASSERT(pCtrl);
	int lower=0,upper=0;
	pCtrl->GetRange(lower,upper);
	pCtrl->SetRange(upper,lower);
}

void CDlgInsertTable::OnOK() 
{
	CDialog::OnOK();
	SaveSettings();
}

void CDlgInsertTable::SaveSettings()
{
	PlugRegUtil::WriteValue(KEY_PATH,COLS,m_nCols);
	PlugRegUtil::WriteValue(KEY_PATH,ROWS,m_nRows);
}

void CDlgInsertTable::OnCancel() 
{
	CDialog::OnCancel();
	SaveSettings();
}

//#define PLUGMAKESTRING(PSTR,IDSTRING) LoadStr(PSTR,StringOrUINT(IDSTRING,#IDSTRING),g_wLangID,m_hInst)

#define MAKESTRING(STRING,IDSTR,WLANGID) \
	PlugLoc::LoadStr(STRING.GetBufferSetLength(MAX_PATH+1),PlugLoc::StringOrUINT(IDSTR,#IDSTR),WLANGID,theApp.m_hInstance); \
	STRING.ReleaseBuffer();

void CDlgInsertTable::Localize()
{
	CString s;
	MAKESTRING(s,IDS_INSERTTABLE,m_wLangID);
	SetWindowText(s);

	CWnd* pWnd;
	pWnd=GetDlgItem(IDC_STATIC_COLS);
	ASSERT(pWnd);
	//s=LocUtil::LoadString(MAKESTRINGID(IDS_COLUMNSNUMBER),m_wLangID);
	MAKESTRING(s,IDS_COLUMNSNUMBER,m_wLangID);
	pWnd->SetWindowText(s);

	pWnd=GetDlgItem(IDC_STATIC_ROWS);
	ASSERT(pWnd);
	//s=LocUtil::LoadString(MAKESTRINGID(IDS_ROWSNUMBER),m_wLangID);
	MAKESTRING(s,IDS_ROWSNUMBER,m_wLangID);
	pWnd->SetWindowText(s);

	pWnd=GetDlgItem(IDCANCEL);
	ASSERT(pWnd);
	//s=LocUtil::LoadString(MAKESTRINGID(IDS_CANCEL),m_wLangID);
	MAKESTRING(s,IDS_CANCEL,m_wLangID);
	pWnd->SetWindowText(s);
}

