// PlugRegUtil.cpp: implementation of the PlugRegUtil class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PlugRegUtil.h"

BOOL PlugRegUtil::ReadValue(LPCTSTR lpszRegPath, LPCTSTR lpszValueName
							, const BOOL bDefaultValue)
{
	HKEY hkey=NULL;
	BOOL bRet=bDefaultValue;
	if (ERROR_SUCCESS==RegOpenKeyEx(HKEY_CURRENT_USER,lpszRegPath,0,KEY_QUERY_VALUE,&hkey)) {
		DWORD dwType=REG_DWORD;
		DWORD dwSize=sizeof(BOOL);
		::RegQueryValueEx(hkey,lpszValueName,NULL,&dwType,(LPBYTE)&bRet,&dwSize);
		RegCloseKey(hkey);
	}
		
	return bRet;
}

BOOL PlugRegUtil::WriteValue(LPCTSTR lpszRegPath, LPCTSTR lpszValueName, const BOOL bValue)
{
	HKEY hkey=NULL;
	if (ERROR_SUCCESS==::RegCreateKey(HKEY_CURRENT_USER,lpszRegPath,&hkey)) {
		::RegSetValueEx(hkey,lpszValueName,0,REG_DWORD,(BYTE*)&bValue,sizeof(BOOL));
		RegCloseKey(hkey);
		return TRUE;
	}
	else
		return FALSE;
}

LPCTSTR ConcKey(LPCTSTR lpszKey)
{
	const int nKeyLen=strlen(lpszKey);
	LPCTSTR lpszPath="Software\\G&G Software\\Aml Pages\\Plugins\\";
	const int nPathLen=strlen(lpszPath);
	LPTSTR pRet=(LPTSTR)VirtualAlloc(NULL,nPathLen+nKeyLen+1,MEM_COMMIT,PAGE_READWRITE);
	strcat(pRet,lpszPath);
	strcat(pRet,lpszKey);
	return pRet;
}

BOOL PlugRegUtil::ReadValueFromAmlPages(LPCTSTR lpszKeyName
										, LPCTSTR lpszValueName
										, const BOOL bDefaultValue)
{
	LPCTSTR lpszPath=ConcKey(lpszKeyName);
	const BOOL b=ReadValue(lpszPath,lpszValueName,bDefaultValue);
	VirtualFree((void*)lpszPath,0,MEM_RELEASE);
	return b;
}

BOOL PlugRegUtil::WriteValueFromAmlPages(LPCTSTR lpszKeyName
										 , LPCTSTR lpszValueName
										 , const BOOL bValue)
{
	LPCTSTR lpszPath=ConcKey(lpszKeyName);
	const BOOL b=WriteValue(lpszPath,lpszValueName,bValue);
	VirtualFree((void*)lpszPath,0,MEM_RELEASE);
	return b;
}

BOOL PlugRegUtil::ReadValueFromAmlPages(LPCTSTR lpszKeyName
										, LPCTSTR lpszValueName
										, LPTSTR szValue
										, const UINT nMaxValueBytes)
{
	LPCTSTR lpszPath=ConcKey(lpszKeyName);
	HKEY hkey=NULL;
	if (ERROR_SUCCESS==RegOpenKeyEx(HKEY_CURRENT_USER,lpszPath,0,KEY_QUERY_VALUE,&hkey)) {
		DWORD dw=nMaxValueBytes;
		DWORD dwType=REG_SZ;
		const long l=::RegQueryValueEx(hkey,lpszValueName,NULL,&dwType,(LPBYTE)szValue,&dw);
		RegCloseKey(hkey);
		return (ERROR_SUCCESS==l);
	}
	else
		return FALSE;
}

BOOL PlugRegUtil::WriteValueFromAmlPages(LPCTSTR lpszKeyName
										 , LPCTSTR lpszValueName
										 , LPCTSTR lpszValue)
{
	LPCTSTR lpszPath=ConcKey(lpszKeyName);
	HKEY hkey=NULL;
	if (ERROR_SUCCESS==::RegCreateKey(HKEY_CURRENT_USER,lpszPath,&hkey)) {
		const LONG l=::RegSetValueEx(hkey,lpszValueName,0,REG_SZ,(BYTE*)lpszValue,strlen(lpszValue)*sizeof(TCHAR));
		RegCloseKey(hkey);
		return ERROR_SUCCESS==l;
	}
	else
		return FALSE;

}

BOOL PlugRegUtil::ReadValue(LPCTSTR lpszRegPath
							, LPCTSTR lpszValueName
							, LPTSTR lpszValue
							, const int nMaxBytes)
{
	HKEY hkey=NULL;
	BOOL bRet=FALSE;
	if (ERROR_SUCCESS==RegOpenKeyEx(HKEY_CURRENT_USER,lpszRegPath,0,KEY_QUERY_VALUE,&hkey)) {
		DWORD dwType=REG_SZ;
		DWORD dwSize=nMaxBytes;
		const LONG lRead=::RegQueryValueEx(hkey
		,lpszValueName
		,NULL
		,&dwType
		,(LPBYTE)lpszValue,&dwSize);
		RegCloseKey(hkey);
		bRet=(ERROR_SUCCESS == lRead);
	}
		
	return bRet;
}

BOOL PlugRegUtil::ReadAmlPagesExePath(LPTSTR lpszPath, const int nMaxSymbols)
{
	return ReadValue(TEXT("Software\\G&G Software\\Aml Pages"),TEXT("AmlPagesExePath"),lpszPath,nMaxSymbols*sizeof(TCHAR));

}
