// TblMaker.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <atlbase.h>//
#include "TblMaker.h"//our plugin definitions
#include "DlgInsertTable.h"//dialog for get numbers of rows(columns)
#include "RichUtilBase.h"//RichEdit Utilities (In-out, etc)
#include "TomUtil.h"//RichEdit Utilities (In-out, etc)

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CTblMakerApp theApp;
static WORD g_wLangID=0;
//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

BEGIN_MESSAGE_MAP(CTblMakerApp, CWinApp)
	//{{AFX_MSG_MAP(CTblMakerApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CTblMakerApp::CTblMakerApp()
{
}

#define PLUGMAKESTRING(PSTR,IDSTRING) PlugLoc::LoadStr(PSTR,PlugLoc::StringOrUINT(IDSTRING,#IDSTRING),g_wLangID,theApp.m_hInstance)

//Common Plugin Information (required implementation)
extern "C"
BOOL __declspec(dllexport) Aml_GetPluginInfo(AML_PLUGIN_INFO* p)
{
	if (p->cbSize>=SIZE_AML_PLUGIN_INFO_VER2)
		g_wLangID=p->wLanguage;

	//strcpy(p->szMenuName,LocUtil::LoadString(MAKESTRINGID(IDS_TITLE),g_wLangID));
	PLUGMAKESTRING(p->szMenuName,IDS_TITLE);
	p->nMenuCount=2;//menu items count
	
	return TRUE;//OK
}

//Menu Item Information (required if plugin has menu)
extern "C"
BOOL __declspec(dllexport) Aml_GetMenuItemInfo(UINT nIndex, AML_MENU_ITEM_INFO* p)
{
	BOOL bRet=TRUE;//default return value
	
	switch(nIndex) {
	case 0://first menu (all menu==1, see Aml_GetPluginInfo);
		PLUGMAKESTRING(p->szMenuName,IDS_CREATETABLE);
		PLUGMAKESTRING(p->szTTHint,IDS_CREATETABLETT);
		p->nPluginType=APPT_PAGECONTENT;//type of plugin (text editor extension)
		p->lParam=g_wLangID;
		strcpy(p->szFunctionName,"CreateTableProc");//exportable name of plugin function
		p->dwFlags=APF_MENUINSERT;
		break;
	case 1:
		PLUGMAKESTRING(p->szMenuName,IDS_SELECTROW);
		PLUGMAKESTRING(p->szTTHint,IDS_SELECTROWTT);
		p->nPluginType=APPT_PAGECONTENT;//type of plugin (text editor extension)
		p->lParam=g_wLangID;
		strcpy(p->szFunctionName,"SelectProc");//exportable name of plugin function
		break;
		
	default:
		//never???
		ASSERT(FALSE);
		bRet=FALSE;
	};

	return bRet;//OK
}

#define MAKESTRINGORUINT(ID) PlugLoc::StringOrUINT(ID,#ID) 
//check page type
//Plain Text no support tables
bool CheckPageType(const PAGE_TYPE pt, const WORD wLangID)
{
//#ifndef _DEBUG
	if (PT_TEXT==pt) {//plain text page???
		TCHAR sz[MAX_PATH+1]={0};
		//PLUGMAKESTRING(sz,IDS_PLAINTEXTWARNING);
		PlugLoc::LoadStr(sz,MAKESTRINGORUINT(IDS_PLAINTEXTWARNING),wLangID,theApp.m_hInstance);
		AfxMessageBox(sz,MB_ICONEXCLAMATION);
		return false;
	}
	else
		return true;
//#else//for debug version
//	return true;
//#endif//#ifndef _DEBUG
}

//make rtf-string with tables
CString GetTableRTFString(const UINT nRows, const UINT nCols)
{
    CString strPrev = "{\\rtf1";
    CString strTable = strPrev + 
        "\\ansi\\ansicpg1251\\deff0\\deflang5033{\\fonttbl"
        "{\\f0\\froman\\fprq2\\fcharset0 Times New Roman;}"
        "{\\f1\\fswiss\\fcharset0 Arial;}}"
		"{\\*\\Aml Pages;}\\viewkind4\\uc1";
    
    const CString strRow = "\\trowd\\trgaph108\\trleft8\\"  
          "trbrdrl\\brdrs\\brdrw10 \\trbrdrt\\"
          "brdrs\\brdrw10 \\trbrdrr\\brdrs\\" 
          "brdrw10 \\trbrdrb\\brdrs\\brdrw10 \\"
          "trpaddl08\\trpaddr108\\trpaddfl3\\trpaddfr3";
    const CString strCol= "\\clbrdrl\\brdrw10\\brdrs\\clbrdrt\\brdrw10\\brdrs\\clbrdrr\\"
        "brdrw10\\brdrs\\clbrdrb\\brdrw10\\brdrs\\cellx";
   
	const CString endcell = "\\cell";
    const CString endrow = "\\row";
    const int width = 8748/nCols;
    CString strColw;
 
    // Loop for numbers of rows
    for(UINT i=0;i<nRows;i++)
    {
        strTable += strRow ;

        // Loop for number of columns
        for(UINT j=0;j<nCols;j++)
        {
            strTable += strCol;
            strColw.Format(_T("%d"),width *(j+1));
            strTable += strColw;
        }
        strTable += "\\pard\\intbl";
        for(j=0;j<nCols;j++)
        {
            strTable += endcell;
        }
        strTable += endrow;
    }
    strTable += "\\par}";
	return strTable;	
}

//Display Modal Dialog for quest of rows,cols
bool DialogTable(UINT& nRows, UINT& nCols, const WORD wLangID)
{
	//reqired for using dialog template for resources of our DLL
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CDlgInsertTable dlg(wLangID);
	if (dlg.DoModal()==IDOK) {
		nRows=dlg.m_nRows;
		nCols=dlg.m_nCols;
		return true;
	}
	else
		return false;
}

//insert table string direct to RichEdit
bool InsertTable(const HWND hwndRichEdit, const WORD wLangID)
{
	UINT nRows=0; UINT nCols=0;
	if (!DialogTable(nRows,nCols,wLangID))//display dialog ???
		return true;//OK. No error. Cancelled by user

	//make table string
	const CString strTable=GetTableRTFString(nRows,nCols);
	
	//checke selection
	CHARRANGE cr={0};
	SendMessage(hwndRichEdit,EM_EXGETSEL,0,(LPARAM)&cr);
	if (cr.cpMax-cr.cpMin) {//exist selection????
		cr.cpMax=cr.cpMin;//unselect
		SendMessage(hwndRichEdit,EM_EXSETSEL,0,(LPARAM)&cr);
	}

	//insert RTF-text to RichEdit
	return RichUtilBase::TextIn(hwndRichEdit
		,true//as selected text
		,false//NO as plain text. As RTF-code
		,strTable//RTF code
		,NULL,0);//callback, lParam - ignored

}

//Get BSTR from LPCTSTR (for old versions of Aml Pages)
BSTR BSTRFromLPCTSTR(LPCTSTR lpsz)
{
	if ((!lpsz) || (!strlen(lpsz))) return NULL;

	const int nLen = MultiByteToWideChar(CP_ACP, 0, lpsz,
		strlen(lpsz) ,NULL, NULL);
	
	BSTR bstr = ::SysAllocStringLen(NULL, nLen);
	
	if (bstr )
		MultiByteToWideChar(CP_ACP, 0, lpsz, strlen(lpsz),bstr, nLen);

	return bstr;
}

//creation of table for old Aml Pages verions 
BOOL CreateTableProcForOldVersion(AML_PAGECONTENT& pc)
{
	UINT nRows=0;UINT nCols=0;
	//Dialplay modal dialog for 
	if (!DialogTable(nRows,nCols,(WORD)pc.lParam))
		return TRUE;//User cancelled

	//make RTF-code string
	const CString strText=GetTableRTFString(nRows,nCols);
	
	if (pc.bstrContent)//if memory - free
		SysFreeString(pc.bstrContent);

	//make BSTR string from C-string (LPCTSTR)
	pc.bstrContent=BSTRFromLPCTSTR(strText);

	pc.bChanged=TRUE;//Yes. Our is changed content of text
	pc.dwFlags=APFRIO_SEL;//Our is changed selected text only
	
	return TRUE;//OK! [Zaebis! (russian equivalent of english "OK":), see Remarks]
	
	/*Remarks
	  ~~~~~~~
	If You is russian developer, You can definition eg
	#define ZAEBIS TRUE
	#define BLA FALSE	
	*/
}

//Menu Item Command Handler
extern "C"
BOOL __declspec(dllexport) CreateTableProc(AML_PAGECONTENT* p)
{
	//if page of plain text - Exit (plain text no support tables)
	if (!CheckPageType(p->pageType,(WORD)p->lParam))
		return TRUE;

	//check version of structure
	if (SIZE_AML_PAGECONTENT_VER2>p->cbSize) {//if old version Aml Pages
		//HWND of RichEdit not extist of AML_PAGECONTENT
		//use making RTF code
		//see plugins.h definitions
		return CreateTableProcForOldVersion(*p);
	}
	//else
	//Insert RTF-code directly to RichEdit HWND
	const BOOL bRet=(true==InsertTable(p->hwnd,(WORD)p->lParam));
	//OK?
	return bRet;
}

extern "C"
BOOL __declspec(dllexport) SelectProc(AML_PAGECONTENT* p)
{
	CHARRANGE cr;
	const HWND hwnd=p->hwnd;
	SendMessage(hwnd,EM_EXGETSEL,0,(LPARAM)&cr);
	CComPtr<ITextRange> Range=CTomUtil::GetITextRange(hwnd,cr);
	Range->SetStart(cr.cpMin);
	const HRESULT hr=Range->EndOf(tomRow,tomExtend,0);
	if (S_OK==hr) {
		Range->GetStart(&cr.cpMin);
		Range->GetEnd(&cr.cpMax);
		PostMessage(hwnd,EM_SETSEL,cr.cpMin,cr.cpMax);
	}
	return true;
}
