// TomUtil.h: interface for the CTomUtil class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TOMUTIL_H__B701EE37_56C6_11D8_AE74_FE5EEE277B59__INCLUDED_)
#define AFX_TOMUTIL_H__B701EE37_56C6_11D8_AE74_FE5EEE277B59__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "Tom\tom.h"

struct ITextRange;

enum {FNR_NOCORRECTRANGE=1	//  ITextRange     callback-
	, FNR_STRINGCHANGED=2	//  	
};//enum

typedef bool (* PFUNC_FINDTEXTPROC)(ITextRange& range,CHARRANGE crText, CString& strFind, LPARAM lParam,long& lFlags);

class CTomUtil  
{
public:
	static bool SetProtectedForAllText(const HWND hwndRichEdit, const bool bProtect);
	static int FindTextSimple(const HWND hwndRE, LPCTSTR lpszText, const long lStart);
	static ITextFont* GetITextFont(const HWND hwnd);
	static ITextFont* GetITextFontForRange(const HWND hwnd, const long lStart, const long lEnd);
	static bool SetUnderlineRed(ITextRange* const pRange, const long lUnderlineType);
	static bool ReplaceText(const HWND hwnd, LPCTSTR lpszText, const long lStart, const long lEnd);
	static bool SetHiddenText(const HWND hwnd, const bool bHidden, const long lStart, const long lEnd);
	static bool ReplaceSel(const HWND hwnd, LPCTSTR lpszText);
	static CString GetTextFromRange(const HWND hwndRich, const CHARRANGE& cr);
	static CString GetTextFromRange(const HWND hwndRich, const long lBegin, const long lEnd);
	static UINT FindText(const HWND hwndRE, LPCTSTR lpszFind, const bool bMatchCase, const bool bWholeWord, const long lStart, const long lEnd, PFUNC_FINDTEXTPROC pfn, const LPARAM lParam);
	static UINT FindText(const HWND hwndRE, LPCTSTR lpszFind, const long lTOMOptions, const long lStart, const long lEnd, PFUNC_FINDTEXTPROC pfn, const LPARAM lParam);
	static bool SuspendUndo(const HWND hwndRich, const bool bSuspend);
	static bool SuspendUndo(ITextDocument* const pDoc, const bool bSuspend);
	static ITextDocument* GetITextDocument(const HWND hwnd);
	static bool PasteFileAsWordDocument(const HWND hwndRich, LPCTSTR lpszPathName);
	static bool IsEnabledOVRMode(const CRichEditCtrl& rich);
	static ITextRange* GetSelectedITextRange(const CRichEditCtrl& rich);
	static ITextRange* CTomUtil::GetITextRange(const HWND hwnd, const CHARRANGE& cr);
	static ITextRange* GetITextRange(const CRichEditCtrl& rich, const CHARRANGE& cr);
	static ITextPara* GetITextPara(const CRichEditCtrl& rich);
	static ITextRange* GetITextRange(const CRichEditCtrl& rich);
	static ITextDocument* GetITextDocument(const CRichEditCtrl& rich);
	static BOOL DisableInsertMode(const CRichEditCtrl& rich, const BOOL bDisabled);
private:
	static bool SetProtectedForAllTextByAPI(const HWND hwnd, const bool bProtect);
};

#endif // !defined(AFX_TOMUTIL_H__B701EE37_56C6_11D8_AE74_FE5EEE277B59__INCLUDED_)
